unit Main;

interface

{$IFDEF VER140}
  {$DEFINE SMForDelphi6}
{$ENDIF}

{$IFDEF VER150}
  {$DEFINE SMForDelphi6}
  {$DEFINE SMForDelphi7}
{$ENDIF}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBTables, StdCtrls, ComCtrls, SMIBase, SMIWiz,
  ExtCtrls {$IFDEF SMForDelphi6} , Variants {$ENDIF};

type
  TfrmMain = class(TForm)
    dSrc: TDataSource;
    tbl: TTable;
    SMIWizardDlg: TSMIWizardDlg;
    pnlTop: TPanel;
    btnImport: TButton;
    btnAbout: TButton;
    DBGrid: TDBGrid;
    procedure btnImportClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure SMIWizardDlgShow(Sender: TObject);
  private
    { Private declarations }
    procedure CustomButtonClick(Sender: TObject);
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}
{$R winxp.res}
uses ShellAPI;

procedure TfrmMain.btnImportClick(Sender: TObject);
begin
  SMIWizardDlg.Execute
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  tbl.DatabaseName := ExtractFilePath(Application.ExeName);
  tbl.Open;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  tbl.Close;
end;

procedure TfrmMain.btnAboutClick(Sender: TObject);
begin
  SMIWizardDlg.AboutSMI
end;

procedure TfrmMain.SMIWizardDlgShow(Sender: TObject);
var
  wizard: TfrmSMIWizard;
begin
  wizard := TfrmSMIWizard(Sender);

  with TButton.Create(wizard) do
    try
      Parent := wizard;
      Anchors := [akLeft, akBottom];

      Left := 110;
      Top := 275;
      Caption := 'Open file';

      OnClick := CustomButtonClick
    finally
    end;
end;

procedure TfrmMain.CustomButtonClick(Sender: TObject);
var
  btn: TButton;
  wizard: TfrmSMIWizard;
  strFileName: string;
begin
  btn := TButton(Sender);
  wizard := TfrmSMIWizard(btn.Parent);
  strFileName := wizard.edFileName.Text;
  strFileName := ExpandFileName(strFileName);

  ShellExecute(0, 'open', PChar(strFileName), nil, nil, SW_SHOWNORMAL);
end;

end.
