unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBClient, StdCtrls, SMIBase, SMI2Cell, SMI2DBISAM;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    SMImportFromDBISAM: TSMImportFromDBISAM;
    procedure Button1Click(Sender: TObject);
    procedure SMImportFromDBISAMCreateStructure(Sender: TObject;
      Columns: TSMIColumns);
    procedure SMImportFromDBISAMErrorEvent(Sender: TObject;
      Error: Exception; var Abort: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  SMImportFromDBISAM.RowFirst := 1;

  SMImportFromDBISAM.SourceFileName := ExtractFilePath(Application.ExeName) + '\country.dat';

  {start an import process}
  SMImportFromDBISAM.Execute;
end;

procedure TForm1.SMImportFromDBISAMCreateStructure(Sender: TObject;
  Columns: TSMIColumns);
var
  i: Integer;
begin
  {delete all current dataset fields}
  ClientDataSet1.Close;
  ClientDataSet1.FieldDefs.Clear;

  {create a structure by parsed columns from file}
  for i := 0 to Columns.Count-1 do
  begin
    if Columns[i].Size = 0 then
      Columns[i].Size := 30;

    if (Columns[i].FieldName = '') then
      Columns[i].FieldName := 'Field' + IntToStr(i);

    case Columns[i].DataType of
      itString: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftString, Columns[i].Size, False);
      itInteger: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftInteger, 0, False);
      itFloat: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftFloat, 0, False);
      itDateTime: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftDateTime, 0, False);
      itDate: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftDate, 0, False);
      itTime: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftTime, 0, False);
      itBoolean: ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftBoolean, 0, False);
      itBLOB: begin
                ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftBLOB, 0, False);
              end;
    else
      ClientDataSet1.FieldDefs.Add(Columns[i].FieldName, ftString, 10, False);
    end;
  end;
  ClientDataSet1.CreateDataset;

  {open a dataset with created fields (from text file)}
  ClientDataSet1.Active := True;
  ClientDataSet1.LogChanges := False;

  {fill default correspondence between fields in dataset and columns in CSV}
  with TSMImportBaseComponent(Sender) do
  begin
    Mappings.Clear;
    Columns2Mapping;
  end
end;

procedure TForm1.SMImportFromDBISAMErrorEvent(Sender: TObject;
  Error: Exception; var Abort: Boolean);
begin
  ShowMessage(Error.Message)
end;

end.
