unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, Db, DBTables;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    DBGrid1: TDBGrid;
    Label1: TLabel;
    edExpression: TEdit;
    btnExpressionBuilder: TButton;
    btnEvaluate: TButton;
    procedure btnExpressionBuilderClick(Sender: TObject);
    procedure btnEvaluateClick(Sender: TObject);
  private
    { Private declarations }
    procedure ParserEvaluate(Sender: TObject; Eval: string; Args: array of Variant;
                             ArgCount: Integer; IsChild: Boolean; var Value: Variant; var Done: Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
uses SMIPars, SMIEBldr;

procedure TForm1.btnExpressionBuilderClick(Sender: TObject);
var
  s: string;
  lstDSs: TList;
begin
  lstDSs := TList.Create;
  try
    {fill a list of available dataset that you want to display for end-user}
    lstDSs.Add(Table1);

    {formula for calculation}
    s := edExpression.Text;

    if ExpressionBuilder(s, lstDSs, nil, nil, False) then
      edExpression.Text := s;
  finally
    lstDSs.Free;
  end
end;

procedure TForm1.btnEvaluateClick(Sender: TObject);
begin
  with TSMIParser.Create(nil) do
    try
      OnEvaluate := ParserEvaluate;
      Text := edExpression.Text;
      ShowMessage('Calculated value is '#13#10#13#10 + VarToStr(Value))
    finally
      Free
    end;
end;

{event where you may return value for any custom variable}
procedure TForm1.ParserEvaluate(Sender: TObject; Eval: string; Args: array of Variant;
                             ArgCount: Integer; IsChild: Boolean; var Value: Variant; var Done: Boolean);
var
  fld: TField;
begin
  if (Eval = 'VarCapital') then
  begin
    Done := True;
    Value := 'Capital';
  end
  else
  if (Copy(Eval, 1, 7) = 'Table1.') then
  begin
    fld := Table1.FindField(Copy(Eval, 8, Length(Eval)-7));
    if Assigned(fld) then
    begin
      Done := True;
      Value := fld.Value
    end
  end;
end;

end.
