unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBTables, StdCtrls, SMIBase, SMI2Cell, SMI2OLE;

type
  TForm1 = class(TForm)
    Button1: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    SMImportFromWord1: TSMImportFromWord;
    Table1: TTable;
    procedure Button1Click(Sender: TObject);
    procedure SMImportFromParadoxCreateStructure(Sender: TObject;
      Columns: TSMIColumns);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  {first row contain the field names}
  SMImportFromWord1.RowFirst := 2;

  SMImportFromWord1.SourceFileName := ExtractFilePath(Application.ExeName) + '\country.doc';

  {start an import process}
  SMImportFromWord1.Execute;
end;

procedure TForm1.SMImportFromParadoxCreateStructure(Sender: TObject;
  Columns: TSMIColumns);
var
  i: Integer;
begin
  {delete all current dataset fields}
  if Table1.Active then
  begin
    Table1.Close;
    DeleteFile(Table1.TableName)
  end;
  Table1.FieldDefs.Clear;

  {create a structure by parsed columns from MS Excel}
  for i := 0 to Columns.Count-1 do
  begin
    if Columns[i].Size = 0 then
      Columns[i].Size := 30;

    case Columns[i].DataType of
      itString: Table1.FieldDefs.Add(Columns[i].FieldName, ftString, Columns[i].Size, False);
      itInteger: Table1.FieldDefs.Add(Columns[i].FieldName, ftInteger, 0, False);
      itFloat: Table1.FieldDefs.Add(Columns[i].FieldName, ftFloat, 0, False);
      itDateTime: Table1.FieldDefs.Add(Columns[i].FieldName, ftDateTime, 0, False);
      itDate: Table1.FieldDefs.Add(Columns[i].FieldName, ftDate, 0, False);
      itTime: Table1.FieldDefs.Add(Columns[i].FieldName, ftTime, 0, False);
      itBoolean: Table1.FieldDefs.Add(Columns[i].FieldName, ftBoolean, 0, False);
    else
      Table1.FieldDefs.Add(Columns[i].FieldName, ftString, 10, False);
    end;
  end;
  Table1.CreateTable;

  {open a dataset with created fields (from text file)}
  Table1.Active := True;

  {fill default correspondence between fields in dataset and columns in CSV}
  with TSMImportBaseComponent(Sender) do
  begin
    Mappings.Clear;
    Columns2Mapping;
  end
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Table1.DatabaseName := ExtractFilePath(Application.ExeName);
  Table1.TableName := 'smi.dbf';
end;

end.
