unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Grids, DBGrids, Db, DBTables, StdCtrls, SMIBase, SMI2TXT;

type
  TfrmMain = class(TForm)
    dSrcPerson: TDataSource;
    tblPerson: TTable;
    dSrcOperation: TDataSource;
    tblOperation: TTable;
    dbgPerson: TDBGrid;
    dbgOperation: TDBGrid;
    Splitter1: TSplitter;
    pnlToolbar: TPanel;
    btnImport: TButton;
    SMImportFromText1: TSMImportFromText;
    procedure FormCreate(Sender: TObject);
    procedure btnImportClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  {open tables from application folder}
  tblPerson.DatabaseName := ExtractFilePath(Application.ExeName);
  tblPerson.Open;

  tblOperation.DatabaseName := ExtractFilePath(Application.ExeName);
  tblOperation.Open;
end;

procedure TfrmMain.btnImportClick(Sender: TObject);
begin
  {load CSV file with different record types (depends from first character in text)}
  SMImportFromText1.SourceFileName := ExtractFilePath(Application.ExeName) + 'data.csv';
  SMImportFromText1.FieldDelimiter := fdSemicolon;
  SMImportFromText1.TextQualifier := tqNone;
  SMImportFromText1.DataFormats.DateOrder := doMDY;
  SMImportFromText1.DataFormats.LeadingZerosInDate := True;
  SMImportFromText1.DataFormats.FourDigitYear := True;
  SMImportFromText1.DataFormats.DecimalSeparator := '.';

  {1. load all person records (first character is 'A')}
  SMImportFromText1.Dataset := tblPerson;
  SMImportFromText1.LoadCondition.LoadWhen := 'SubString(Text, 1, 1) = "A"';
  SMImportFromText1.Mappings.Clear;
  SMImportFromText1.Mappings.Add('ID=Field2');
  SMImportFromText1.Mappings.Add('Name=Field3');
  SMImportFromText1.Execute;

  {2. load all rows for operations (first character is 'B')}
  SMImportFromText1.Dataset := tblOperation;
  SMImportFromText1.LoadCondition.LoadWhen := 'SubString(Text, 1, 1) = "B"';
  SMImportFromText1.Mappings.Clear;
  SMImportFromText1.Mappings.Add('PersonID=Field2');
  SMImportFromText1.Mappings.Add('DT=Field3');
  SMImportFromText1.Mappings.Add('Total=Field4');
  SMImportFromText1.Execute;
end;

end.
